#ifndef __GLTEXT__
#define __GLTEXT__

/*
	Splits up a texture into 256 pieces and shows the correspondent piece of the
	character in the text.
*/
#include "mystuff/mpc.h" //Used to create a font texture;


class glText
{
public:
	GLVECTOR2f vertex[256*4];
	GLuint texture;
	GLVECTOR3f *color;
	void setup(GLVECTOR3f *col,GLuint usethistexture);
	void print(GLVECTOR3f *start,GLVECTOR3f *len,char *txt,int slen = -1);
};



void glText::print(GLVECTOR3f *start,GLVECTOR3f *len,char *t,int slen)
{

	static WORD lenstr;
	static WORD num;
	static GLVECTOR3f v;
	static unsigned char *txt;
	txt = (unsigned char*)t;
	if (slen == -1)
	lenstr = strlen(t);
	else lenstr = slen;
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D,texture);
	glBegin(GL_QUADS);
	for (num = 0; num < lenstr; num++)
	{	
		v.x = start->x+len->x*num;
		v.y = start->y;
		v.z = start->z;
		glTexCoord2fv((float*)&vertex[txt[num]*4]);
		glVertex3fv((float*)&v);
		v.x += len->x;
		glTexCoord2fv((float*)&vertex[txt[num]*4+1]);
		glVertex3fv((float*)&v);
		v.y -= len->y;
		glTexCoord2fv((float*)&vertex[txt[num]*4+2]);
		glVertex3fv((float*)&v);
		v.x -= len->x;
		glTexCoord2fv((float*)&vertex[txt[num]*4+3]);
		glVertex3fv((float*)&v);	
	}
	glEnd();

}

void glText::setup(GLVECTOR3f *col,GLuint usethistexture)
{
	color = col;

/*	if (usethistexture == -1)
	texture = LoadGLTexture(MAKEINTRESOURCE(IDB_ASCII),1);
	else texture = usethistexture;
*/
	texture = usethistexture;
	DWORD xnum,ynum,pos;
	float step = 1.0f/16.0f;
	pos = 0;
	for (ynum = 0; ynum < 16; ynum++)
		for (xnum = 0; xnum < 16; xnum++)
		{
			vertex[pos].x = step*(float)xnum;
			vertex[pos].y = step*(float)ynum;
			pos++;
			vertex[pos].x = step*(float)(xnum+1);
			vertex[pos].y = step*(float)(ynum);
			pos++;
			vertex[pos].x = step*(float)(xnum+1);
			vertex[pos].y = step*(float)(ynum+1);
			pos++;
			vertex[pos].x = step*(float)(xnum);
			vertex[pos].y = step*(float)(ynum+1);
			pos++;
		}
}









#endif
