#ifndef __ENTITY_TANK01TURRET__
#define __ENTITY_TANK01TURRET__


class EN_TankTemplate_Pipe : public Entity
{
	public:
	int toggle;
	GLVECTOR3f *targetdir;
	GLVECTOR3f *cleantargetdir;
	GLuint texture;
	int flarecount;
	int renderme() {defaultrender(); renderflare();return(1);};
	int moveme();
	int init();
	int beforesave() {return(1);}; //Do preparing stuff before saving. (Fill the savebuffer, for example?)
	int afterload() {return(1);};  //Do initializing stuff after loading. Will be called AFTER init();
	void renderflare();
};


void EN_TankTemplate_Pipe::renderflare()
{
	if (flarecount)
	{
		glDepthMask(GL_FALSE);
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE);
		glColor3f(1,0.4,0.1);
		glBindTexture(GL_TEXTURE_2D,texture);
		glBegin(GL_QUADS);
			glTexCoord2f(0,0);
			glVertex3f(-0.3,0,-2);
			glTexCoord2f(1,0);
			glVertex3f(0.3,0,-2);
			glTexCoord2f(1,1);
			glVertex3f(0.3,0,-5);
			glTexCoord2f(0,1);
			glVertex3f(-0.3,0,-5);
		glEnd();
		glDisable(GL_BLEND);
		glDepthMask(GL_TRUE);
		flarecount--;
	}
	
}

int EN_TankTemplate_Pipe::moveme()
{
//	if (keys[SDLK_UP]) dir.x += 2;
//	if (keys[SDLK_DOWN]) dir.x -= 2;	
	if (targetdir->x > 10) targetdir->x = 10;
	if (targetdir->x < -80) targetdir->x = -80;
	dir.x = targetdir->x;


	if (impulse[0] && !toggle)
	{
		flarecount = 10;
		EN_SmallRocket *s = new EN_SmallRocket;
		parent->parent->bringup[ambringup] = s;
		parent->parent->ambringup++;
		s->pos = parent->parent->pos + parent->pos + pos;
		s->dir = *cleantargetdir;
		toggle = 20;
	}
	if (toggle) toggle--;

	return(1);
}

int EN_TankTemplate_Pipe::init()
{
	toggle = 0;
	flarecount = 0;
	M3a *m = new M3a;
	m->load("data\\models\\tank01pipe.m3a");
	texture = currentworld->texturehandler.gettexture(currentworld->texturehandler.load("data\\textures\\alphaball.mpc",2));
	model[0] = m;	
	return(1);
}




class EN_TankTemplate_Turret : public Entity
{
	public:
	GLVECTOR3f *targetdir;
	GLVECTOR3f *cleantargetdir;
	int renderme() {return(defaultrender());};
	int moveme();
	int init();
	int beforesave() {return(1);}; //Do preparing stuff before saving. (Fill the savebuffer, for example?)
	int afterload() {return(1);};  //Do initializing stuff after loading. Will be called AFTER init();

};


int EN_TankTemplate_Turret::moveme()
{

	dir.y = targetdir->y;
	return(1);
}

int EN_TankTemplate_Turret::init()
{
	M3a *m = new M3a;
	m->load("data\\models\\tank01turret.m3a");
	model[0] = m;

	EN_TankTemplate_Pipe *p = new EN_TankTemplate_Pipe;
	p->targetdir = targetdir;
	p->cleantargetdir = cleantargetdir;
	addchild(p);

	return(1);
}



#endif